
Framework BRL.GLMax2D
Import BRL.RamStream
Import BRL.PNGLoader
Import BRL.Timer
Import BRL.Random
Import Brl.Keycodes

' modules which may be required:
' Import BRL.BMPLoader
' Import BRL.TGALoader
' Import BRL.JPGLoader


SetGraphicsDriver GLMax2DDriver()




AppTitle="Fliegenklatsche - Lord Stweccys' miniGames"

Graphics 800,600,0


Local lvl=0 '2=Fettfliege '1=Spinne '3=Biene 'Auf Zeit
Local s[10,3]
Local scount=0
Local timewait:Int
Local score:Int=0

For I=0 To 9
s[i,0]=1000
Next


SetClsColor 255,255,255
Cls
SetBlend(ALPHABLEND)



Incbin "f.png"
Incbin "fk.png"
Incbin "schleim.png"
Incbin "fettf.png"
Incbin "watch.fett.png"
Incbin "flatsch.png"
Incbin "ente.png"
Incbin "lost.png"
Incbin "flatsch2.png"
Incbin "bee.png"
Incbin "spinne.png"
Incbin "watch.spider.png"
Incbin "watch.bee.png"
Incbin "watch.time.png"

fliege:TImage=LoadImage("incbin::f.png",FILTEREDIMAGE+MASKEDIMAGE)
bee:TImage=LoadImage("incbin::bee.png")
klatsche:TImage=LoadImage("incbin::fk.png",FILTEREDIMAGE+MASKEDIMAGE)
schleim:TImage=LoadImage("incbin::schleim.png",FILTEREDIMAGE+MASKEDIMAGE)
fett:TImage=LoadImage("incbin::fettf.png",FILTEREDIMAGE+MASKEDIMAGE)
mpic:TImage=LoadImage("incbin::flatsch.png",FILTEREDIMAGE+MASKEDIMAGE)
spinne:TImage=LoadImage("incbin::spinne.png",FILTEREDIMAGE+MASKEDIMAGE)



tpic0:TImage=LoadImage("incbin::watch.fett.png")
tpic1:TImage=LoadImage("incbin::watch.spider.png")
tpic2:TImage=LoadImage("incbin::watch.bee.png")
tpic3:TImage=LoadImage("incbin::watch.time.png")


SetImageHandle klatsche,148,154

MidHandleImage fliege
MidHandleImage bee
MidHandleImage schleim
MidHandleImage fett
MidHandleImage mpic

Local x#=400,y#=300,turn#,turnspeed#,speed#=1
Local fettx#=900,fetty#=300
Local punkte

hit=2

Global timer=CreateTimer(60)

file=ReadFile("save.txt")

i=0

If file<>0
x=Float(ReadLine(file))
y=Float(ReadLine(file))
turn=Float(ReadLine(file))
turnspeed=Float(ReadLine(file))
speed=Int(ReadLine(file))
fettx=Float(ReadLine(file))
fetty=Float(ReadLine(file))
lvl=Int(ReadLine(file))
punkte=Int(ReadLine(file))
score=Int(ReadLine(file))
CloseFile file
i=1
EndIf

#menu
'MEN 'Eher zum Neustart!

If i=0

x=400
y=300
turn=0
turnspeed=0
speed=1
fettx=900
fetty=300
lvl=0
For i=0 To 10
s[i,2]=1
Next



'Alle Variablen Resetten


#start
punkte=0
EndIf
'Hier startet das Spiel

While Not KeyHit(KEY_ESCAPE)



'Schleim malen

SetRotation 0
SetScale 1,1

For I=0 To 9
SetAlpha 1
If s[i,2]<=100 SetAlpha s[i,2]/100.0
DrawImage schleim,s[i,0],s[i,1]
s[i,2]=s[i,2]-1
If s[i,2]<0 s[i,2]=0
Next

SetAlpha 1


'Fettfliege malen

If lvl=2

rot#=(ATan2(y-fetty,x-fettx) Mod 360) +90

SetRotation rot

DrawImage fett,fettx,fetty
entf=Sqr((x-fettx)^2+(y-fetty)^2)
If entf>200
fettx=fettx+Sin(rot)*speed*0.5
fetty=fetty+Cos(rot-180)*speed*0.5
ElseIf entf<100
fettx=fettx-Sin(rot)*speed*0.5
fetty=fetty-Cos(rot-180)*speed*0.5
EndIf

EndIf

If lvl=1 'Spinne malen

If x<200 And y<150
turnspeed=0
turn=Rand(0,360)
x=Rand(0,800)
y=Rand(0,600)
speed=speed+1
EndIf
SetRotation 0
DrawImage spinne,0,0
EndIf


If lvl=3 'Biene malen

SetRotation turn

If timewait<MilliSecs()
dbee=1-dbee
timewait=MilliSecs()+Rand(1000,7000)
EndIf

If dbee=0 DrawImage fliege,x,y
If dbee=1 DrawImage bee,x,y

EndIf

If lvl=4 'Auf Zeit



If timewait<MilliSecs()
Cls
SetColor 0,0,0
DrawText("Glueckwunsch! Du hast "+punkte+" Punkte erreicht! Das naechste Spiel startet gleich!",0,0)
i=0
If punkte>score
DrawText "Klasse! Mit "+punkte+" Punkten hast du eine neue Bestleistung!",0,20
score=punkte
EndIf
Flip
Delay 1000
FlushMouse()
WaitMouse()
Goto menu
EndIf

EndIf




'Fliege malen

SetAlpha 1

SetRotation turn

turnspeed=turnspeed+Rnd(-0.1,0.1)
If Abs(turnspeed)>1 turnspeed=Rnd(-1,1)
turn=turn+turnspeed*speed
x=x+Sin(turn)*speed
y=y+Cos(turn-180)*speed

If x>800 Or x<0 Or y>600 Or y<0
turn=turn-180
turnspeed=0
EndIf

If turn<0 turn=turn+360
If turn>360 turn=turn-360


If lvl<3 Or lvl=4 DrawImage fliege,x,y



'Schlagwaffe malen^^

SetRotation 0
SetScale kscal#*0.5,kscal*0.5
If kscal>1.5 SetAlpha 1-(kscal-1.5)*2


If MouseHit(1)
kscal=2
hit=0
EndIf
If hit=0 kscal=kscal-0.1
If hit=0 And kscal<1
hit=1
entf=Sqr((x-MouseX())^2+(y-MouseY())^2)
	If entf<50
	If dbee=0
	s[scount,0]=x
	s[scount,1]=y
	s[scount,2]=200
	scount=scount+1
	If scount=10 scount=0
	x=Rand(0,800)
	y=Rand(0,600)
	turnspeed=0
	turn=Rand(0,360)
	punkte=punkte+1
	EndIf
	If dbee=1 punkte=punkte-3
	speed=speed+1
	EndIf
entf=Sqr((fettx-MouseX())^2+(fetty-MouseY())^2)
	If entf<75 And lvl=2
	Slime()
	i=WaitMouse()
	If i=MOUSE_RIGHT
	i=0
	Goto menu
	EndIf
	Goto start
	End
	EndIf
EndIf
If hit=1 kscal=kscal+0.1
If hit=1 And kscal>2 hit=2

If hit<2 DrawImage(klatsche,MouseX(),MouseY())
SetAlpha 1

'Spieltechnisches:

If speed=20 And lvl=0 'Die Fettfliege
DrawMessage(mpic,tpic1)
speed=1
lvl=1
EndIf
If speed=20 And lvl=1 'Die Spinne
fettx=1000
Drawmessage(mpic,tpic0)
speed=1
lvl=2
EndIf
If speed=20 And lvl=2 'Die Biene
Drawmessage(mpic,tpic2)
speed=1
lvl=3
EndIf
If speed=20 And lvl=3 'Auf ZEIT
Drawmessage(mpic,tpic3)
dbee=0
speed=1
lvl=4
timewait=MilliSecs()+30000
EndIf



SetColor 0,0,0
SetScale 1,1
DrawText "Punkte: "+punkte,1,1
If lvl=4 DrawText "Zeit: "+((timewait-MilliSecs())/1000)+"s",500,0
SetColor 255,255,255
WaitTimer timer

Flip
Cls
Wend

file=WriteFile("save.txt")

WriteLine file,x
WriteLine file,y
WriteLine file,turn
WriteLine file,turnspeed
WriteLine file,speed
WriteLine file,fettx
WriteLine file,fetty
WriteLine file,lvl
WriteLine file,punkte
WriteLine file,score

CloseFile file

StopTimer timer

End



Function DrawMessage(mpic:TImage,tpic:TImage)
SetScale 1,1
DrawImage mpic,400,300
DrawImage tpic,400-133,300-67
Flip
Delay 1000
FlushMouse()
WaitMouse()
End Function
Function Slime() 'Alles wird verschleimt!!!!


Local ente:TImage=LoadImage("incbin::ente.png",MASKEDIMAGE+FILTEREDIMAGE)
Local lost:TImage=LoadImage("incbin::lost.png",MASKEDIMAGE+FILTEREDIMAGE)
Local flatsch2:TImage=LoadImage("incbin::flatsch2.png",MASKEDIMAGE+FILTEREDIMAGE)

MidHandleImage ente
MidHandleImage flatsch2

FlushKeys()


For Is#=1 To 2 Step 0.2
SetScale 1.5*Is,1.5*Is
DrawImage flatsch2,400,300
WaitTimer timer
Flip
Next
Cls
flatsch2=Null

SetScale 1,1
Local tri:Float[6]
tri[5]=600
For O=0 To 720
If MouseHit(1) Exit
SetColor 255,255,255
DrawImage lost,0,0
SetColor 255,240,130
For I=0 To 79
tri[0]=I*10
tri[1]=Sin(o*10+i*50)*10+o
tri[2]=I*10+10
tri[3]=Sin(o*10+i*50+50)*10+o
tri[4]=i*10
DrawPoly(tri)
tri[0]=I*10+10
tri[1]=Sin(o*10+i*50+50)*10+o
tri[2]=I*10+10
tri[3]=600
tri[4]=I*10
DrawPoly(tri)
Next
SetRotation (ATan2((Sin(o*10+i*50)*10+o)-(Sin(o*10+i*50+50)*10+o),-10) Mod 360)-180
DrawImage ente,14*10,Sin(o*10+14*50)*10+o-7
SetRotation 0
WaitTimer timer
Flip
Cls
Next
FlushKeys()
End Function